#	include	<stdio.h>
#	include	<stdlib.h>
#	include	<string.h>

#	include	"Global.h"
#	include	"CommandLineParser.h"

static	char
UpperCase(char	ch)
	{
	if((ch>='a')&&(ch<='z'))
		return(ch-'a'+'A');
	return(ch);
	}

static	bool
AreEqual(
	char	*s1,
	char	*s2)
	{
	while((*s1)&&(*s2))
		{
		if(UpperCase(*s1)!=UpperCase(*s2))
			return(false);
		++s1;
		++s2;
		}
	if(*s1)
		return(false);
	if(*s2)
		return(false);
	return(true);
	}

bool
PrintHelp(
	CommandLineArgument	*cla)
	{
	printf("Parameters are set by using -Parameter:value strings.\n");
	printf("  value can be in any reasonable form\n");
	printf("  The following parameters are available (case insensitive):\n");
	int		Index = 0;
	char	s[128];

	int		*iType;
	uint	*uType;
	bool	*bType;
	char	*sType;

	while ( cla[Index].Name )
		{
		sprintf(s, "-%s", cla[Index].Name);
		printf("  %30s:", s);
		switch(cla[Index].Type)
			{
			case	claInteger:		printf("number   ");break;
			case	clauInteger:	printf("unumber  ");break;
			case	claBool:		printf("bool     ");break;
			case	claString:		printf("string   ");break;
			default:
				printf("error");
			}
		printf("default=");
		iType = (int*) cla[Index].Ptr;
		uType = (uint*) cla[Index].Ptr;
		bType = (bool*) cla[Index].Ptr;
		sType = (char*) cla[Index].Ptr;
		switch(cla[Index].Type)
			{
			case	claInteger:	printf("%10d  (0x%8.8x)", *iType, *iType);break;
			case	clauInteger:printf("%10u  (0x%8.8x)", *uType, *uType);break;
			case	claBool:
				if(*bType)
					printf("true");
				else
					printf("false");
				break;
			case	claString: printf("%s", sType); break;
			default:
				printf("error");
			}
		printf("\n");
		++Index;
		}
	return(true);
	}

static	bool
LocateAndSetArgument(
	CommandLineArgument	*cla,
	char				*Parameter,
	char				*Value)
	{
	int		Index = 0;

	int		*iType;
	uint	*uType;
	bool	*bType;
	char	*sType;

	while ( cla[Index].Name )
		{
		if(AreEqual(Parameter, cla[Index].Name))
			{
			iType = (int*) cla[Index].Ptr;
			uType = (uint*) cla[Index].Ptr;
			bType = (bool*) cla[Index].Ptr;
			sType = (char*) cla[Index].Ptr;
			switch(cla[Index].Type)
				{
				case	claInteger:
					if((Value[1]=='x')||(Value[1]=='X'))
						(*iType) = (int)strtol(Value, NULL, 16);
					else
						(*iType) = (int)strtol(Value, NULL, 10);
					break;
				case	clauInteger:
					if((Value[1]=='x')||(Value[1]=='X'))
						(*uType) = (uint)strtoul(Value, NULL, 16);
					else
						(*uType) = (uint)strtoul(Value, NULL, 10);
					break;
				case	claBool:
					if(AreEqual(Value, "false"))
						(*bType) = false;
					else
					if(AreEqual(Value, "true"))
						(*bType) = true;
					else
					if(AreEqual(Value, "no"))
						(*bType) = false;
					else
					if(AreEqual(Value, "yes"))
						(*bType) = true;
					else
					if(Value[0] == '0')
						(*bType) = false;
					else
					if(Value[0] == '1')
						(*bType) = true;
					else
						{
						printf("Error decoding boolean: \"%s\"\n", Value);
						return(-1);
						}
					break;
				case	claString:
					strcpy(sType, Value);
					break;
				default:
					printf("error: mal-formed CLA %s\n", cla[Index].Name);
				}
			return(true);
			}
		++Index;
		}
	printf("Parameter %s is not found try -h\n", Parameter);
	return(false);
	}

int
ParseCommandLine(
	CommandLineArgument	*cla,
	int					argc,
	char				*argv[])
	{
	int		vargc = 1;
	char	s[1024];
	while (vargc < argc)
		{
		if((argv[vargc][0]=='-')||(argv[vargc][1]=='/'))
			{
			if(AreEqual(&argv[vargc][1], "h"))
				{
				PrintHelp(cla);
				return(-1);
				}
			strcpy(s, &argv[vargc][1]);

			char	*field = strchr(s, ':');
			if(!field)
				{
				printf("Malformed argument: %s\n", argv[vargc]);
				return(-1);
				}
			(*field) = '\0';
			++field;
			if(!(*field))
				{
				printf("Malformed argument: %s\n", argv[vargc]);
				return(-1);
				}
			if(!LocateAndSetArgument(cla, s, field))
				{
				printf("Notfound/Malformed argument: %s\n", argv[vargc]);
				return(-1);
				}
			++vargc;
			}
		else
			break;
			
		}
	return(vargc);
	}


