
class	MemoryManagementUnit	:
	public	MemorySystem
	{
	public:
		uint	PageSize;
		uint	Pages;
		uint	PageMask;
		uint	PageShift;
		uint	*PhysicalPages;
		int		*TLBPositions;	// used for fast TLB access
		int		*TLBLRUValues;
		int		*TLBValidBits;
		uint	*TLBVirtualPages;
		uint	TLBSize;

		uint	TranslationDelay;
		uint	TLBMissDelay;

		Counter	TLBHits;
		Counter	TLBMisses;
		
		MemorySystem	*AttachedMemorySystem;


				MemoryManagementUnit ();
		virtual	~MemoryManagementUnit ();

		bool	Initialize (
					uint	aPageSize,
					uint	aPages,
					uint	aTLBSize,
					char	*MemoryMap,
					uint	aTranslationDelay,
					uint	aTLBMissDelay);

		bool	AttachMemorySystem(MemorySystem	*ms);
		bool	PrintConfiguration(int Format=HumanFormat, FILE *fp=stdout);
		bool	PrintStatistics(int Format=HumanFormat, FILE *fp=stdout);
	public:
		virtual	uint8	ReadMemory8(SimAddress);
		virtual	uint16	ReadMemory16(SimAddress);
		virtual	uint32	ReadMemory32(SimAddress);
		virtual	bool	WriteMemory8(SimAddress, uint8);
		virtual	bool	WriteMemory16(SimAddress, uint16);
		virtual	bool	WriteMemory32(SimAddress, uint32);
		virtual	bool	ScheduleOperation(bool, SimAddress,
				int	Bytes,	int	StartAfter,
				int	*UntilStart, int	*UntilFinish);
	};


