
typedef	struct	_ResourceUse
	{
	int			Length;
	bool		Filled;
	int			EventId;
	}	ResourceUse;

// NOTE: Not derived from Component -- Intentionally, for performance
// reasons.

class	Resource
	{
	public:
		// A new data structure is needed.
		Array<ResourceUse>	ResourceUseArray;

		Counter ReferenceTime;
		Counter	BusyCycles;
		Counter	IdleCycles;
		int		opt_LargestGap;
		int		opt_EndTime;
	public:
				Resource ();
		bool	FillHole(
					int	StartAfter,
					int	Length,
					int	EventId,
					int	*StartsAt,
					int	*EndsAt,
					int	*EndTime);
		bool	RequestNewSchedule(
					int	StartAfter,
					int	Length,
					int	EventId,
					int	*StartsAt,
					int	*EndsAt);
		int		SimulateOneClockCycle (bool	IsDrainTick);
		void	Clear();
		bool	Busy();
		void	Sync();
	};

