#	include	"Simulator.h"

//#	define	MaxInstEntry	10000000
#	define	MaxInstEntry	0
// 3 being 100, 1000, and inf.
#	define	MaxH			(20+3)
	
Counter		iiCount=0,ffCount=0,llCount=0,ssCount=0,bbCount=0;
int			iCount=0, fCount=0, lCount=0, sCount=0, bCount=0;

Counter		IntegerH[MaxH][2];
Counter		FloatingH[MaxH][2];
Counter		LoadH[MaxH][2];
Counter		StoreH[MaxH][2];
Counter		BranchH[MaxH][2];

Counter	IntegerRegisters[255];
Counter	FloatingRegisters[255];

bool	RegInstruction_Close();

Counter		LastBasicBlockInstruction = 0;

double	AvgBasicBlockSize, AvgBasicBlockSize2, TotalBasicBlocks;

bool
Increment(
	Counter	Array[MaxH][2],
	int		ZeroOrOne,
	int		Value)
	{
	if(Value>=(MaxH-3))
		{
		if(Value<=100)
			++Array[MaxH-3][ZeroOrOne];
		else
		if(Value<=1000)
			++Array[MaxH-2][ZeroOrOne];
		else
			++Array[MaxH-2][ZeroOrOne];
		}
	else
		++Array[Value][ZeroOrOne];
	return(true);
	}

bool
RegInstruction_p(
	SimAddress	Address,
	int		OP,
	int		O1,
	int		O2,
	int		I1,
	int		I2,
	int		I3,
	int		FLAGS,
	Counter	InstructionCount)
	{
	if(!I1)	I1=200;
	if(!I2)	I2=200;
	if(!I3)	I3=200;

	if ( MaxInstEntry)
	if(	iCount>=MaxInstEntry||
		fCount>=MaxInstEntry||
		lCount>=MaxInstEntry||
		sCount>=MaxInstEntry||
		bCount>=MaxInstEntry	)
		{
		RegInstruction_Close();
		exit(1);
		}

	if(FLAGS & SimIntegerComputationFlag)
		{
		if(I1!=200)
			Increment(IntegerH, 0, InstructionCount - IntegerRegisters[I1]);
		else
			Increment(IntegerH, 0, 0);

		if(I2!=200)
			Increment(IntegerH, 1, InstructionCount - IntegerRegisters[I2]);
		else
			Increment(IntegerH, 1, 0);
		++iCount;
		}
	else
	if(FLAGS & SimFloatingPointComputationFlag)
		{
		if(I1!=200)
			Increment(FloatingH, 0, InstructionCount - FloatingRegisters[I1]);
		else
			Increment(FloatingH, 0, 0);

		if(I2!=200)
			Increment(FloatingH, 1, InstructionCount - FloatingRegisters[I2]);
		else
			Increment(FloatingH, 1, 0);
		++fCount;
		}
	else
	if(FLAGS & SimMemoryLoadFlag)
		{
		if(I2!=200)
			Increment(LoadH, 0, InstructionCount - IntegerRegisters[I2]);
		else
			Increment(LoadH, 0, 0);
		++lCount;
		}
	else
	if(FLAGS & SimMemoryStoreFlag)
		{
		if(I1!=200)
			Increment(StoreH, 0, InstructionCount - IntegerRegisters[I1]);
		else
			Increment(StoreH, 0, 0);
			
		if(I2!=200)
			Increment(StoreH, 1, InstructionCount - IntegerRegisters[I2]);
		else
			Increment(StoreH, 1, 0);
		++sCount;
		}
	else
	if(FLAGS & SimConditionalControlInstructionFlag)
		{	// branch flag
		if(I1!=200)
			Increment(BranchH, 0, InstructionCount - IntegerRegisters[I1]);
		else
			Increment(BranchH, 0, 0);
		if(I2!=200)
			Increment(BranchH, 1, InstructionCount - IntegerRegisters[I2]);
		else
			Increment(BranchH, 1, 0);
		++bCount;
		goto	BranchCalc;
		}
	else
		{
BranchCalc:
		double	Width = InstructionCount - LastBasicBlockInstruction;
		AvgBasicBlockSize += Width;
		AvgBasicBlockSize2 += Width*Width;
		TotalBasicBlocks += 1.0;
		LastBasicBlockInstruction = InstructionCount;
		}
	return(true);
	}

bool
RegInstruction(
	SimAddress	Address,
	int		OP,
	int		O1,
	int		O2,
	int		I1,
	int		I2,
	int		I3,
	int		FLAGS,
	Counter	InstructionCount)
	{
	bool	Ret = RegInstruction_p(Address, OP, O1, O2, I1, I2, I3, FLAGS, InstructionCount);

	//printf("%d, %d <= %d, %d, %d\n", O1, O2, I1, I2, I3);
	IntegerRegisters[O1] = InstructionCount;
	IntegerRegisters[O2] = InstructionCount;
	FloatingRegisters[O1] = InstructionCount;
	FloatingRegisters[O2] = InstructionCount;
	if(FLAGS & SimIntegerComputationFlag)
		++iiCount;
	else
	if(FLAGS & SimFloatingPointComputationFlag)
		++ffCount;
	else
	if(FLAGS & SimMemoryLoadFlag)
		++llCount;
	else
	if(FLAGS & SimMemoryStoreFlag)
		++ssCount;
	else
		++bbCount;

	return(Ret);
	}

bool
PrintHistoGram(
	Counter		Array[MaxH][2],
	int			ZeroOrOne)
	{
	int	Index;
	Counter	Total = 0;
	for(Index=0;Index<MaxH;Index++)
		Total += Array[Index][ZeroOrOne];
	for(Index=0;Index<MaxH;Index++)
		printf("%.1f ", ((double)Array[Index][ZeroOrOne] / (double)Total * 100.0) );

	
	// determine avg and stddev for normal
	double	Sum = 0.0, Sum2 = 0.0, TotalA = 0.0, v;
	for(Index=1;Index<(MaxH-3);Index++)
		{
		Sum += Index*Array[Index][ZeroOrOne];
		Sum2 += Array[Index][ZeroOrOne]*Index*Index;
		TotalA += Array[Index][ZeroOrOne];
		}
	Sum = Sum / TotalA;
	Sum2 = Sum2 / (TotalA);
	v = sqrt(Sum2 - Sum*Sum);
	printf("Avg=%f,o=%f\n", (double)Sum, (double)v);	

	printf("\n");
	return(true);
	}

bool
RegInstruction_Close()
	{
	// calculate average for each
	int	Index = 0;

	printf("I0: ");PrintHistoGram(IntegerH, 0);
	printf("I1: ");PrintHistoGram(IntegerH, 1);
	printf("F0: ");PrintHistoGram(FloatingH, 0);
	printf("F1: ");PrintHistoGram(FloatingH, 1);
	printf("L0: ");PrintHistoGram(LoadH, 0);
	printf("S0: ");PrintHistoGram(StoreH, 0);
	printf("S1: ");PrintHistoGram(StoreH, 1);
	printf("B0: ");PrintHistoGram(BranchH, 0);
	printf("B1: ");PrintHistoGram(BranchH, 1);

	double	Total = iiCount+ffCount+llCount+ssCount+bbCount;
	printf("Integer   : %lld (%f)\n", iiCount, ((double)iiCount/Total));
	printf("Floating  : %lld (%f)\n", ffCount, ((double)ffCount/Total));
	printf("Load      : %lld (%f)\n", llCount, ((double)llCount/Total));
	printf("Store     : %lld (%f)\n", ssCount, ((double)ssCount/Total));
	printf("Branch    : %lld (%f)\n", bbCount, ((double)bbCount/Total));

	AvgBasicBlockSize = AvgBasicBlockSize / TotalBasicBlocks;
	AvgBasicBlockSize2 = AvgBasicBlockSize2 / TotalBasicBlocks;
	double	o = sqrt(AvgBasicBlockSize2 - AvgBasicBlockSize*AvgBasicBlockSize);
	printf("Average Basic Block Size = %.2f, o=%.2f\n", AvgBasicBlockSize, o);
	return(true);
	}

SingleIssueProcessor	::	SingleIssueProcessor ()
	{
	int		Index;

	InstructionCount = 0;
	for(Index=0;Index<32;Index++)
		GeneralPurposeRegisters[Index] = 0;
	for(Index=0;Index<32;Index++)
		FloatingPointRegisters[Index] = 0;
	High = 0;
	Low = 0;
	FloatingPointConditionalFlags = 0;
	ProgramCounter = 0;
	FloatingPointRegistersDoubleAccess = (SimDouble*) &FloatingPointRegisters;
	FloatingPointRegistersSingleAccess = (SimSingle*) &FloatingPointRegisters;

	Stalled = 0;
	Halted = false;
	ProcessorNumber = NumberOfActiveProcessors;
	++NumberOfActiveProcessors;
	}

bool
SingleIssueProcessor	::	PrintStatistics (
	int		Format,
	FILE	*fp)
	{
	PrintValue(Format, fp, "InstructionCount", InstructionCount);
	return(true);
	}

bool
SingleIssueProcessor	::	Halt()
	{
	Halted = true;
	--NumberOfActiveProcessors;
	RegInstruction_Close();
	return(true);
	}

bool
SingleIssueProcessor	::	NotifyAboutStall(
	Component	*From,
	int			Cycles)
	{
	Stalled += Cycles;
	return ( true );
	}

// Bind ss.def into SingleIssueProcessor defination

#	define	SimSetGeneralPurposeRegister(xxx,yyy)	\
		(this->GeneralPurposeRegisters[xxx]=yyy)
#	define	SimGetGeneralPurposeRegister(xxx)	\
		(this->GeneralPurposeRegisters[xxx])
#	define	SimSetHighRegister(xxx)	(this->High = xxx)
#	define	SimGetHighRegister		this->High
#	define	SimSetLowRegister(xxx)	(this->Low = xxx)
#	define	SimGetLowRegister		this->Low
#	define	SimSetFCCRegister(xxx)	(this->FloatingPointConditionalFlags = xxx)
#	define	SimGetFCCRegister		this->FloatingPointConditionalFlags
#	define	SimSetProgramCounter(xxx)	(this->NextProgramCounter = xxx)
#	define	SimGetProgramCounter	this->ProgramCounter
#	define	SimSetTargetProgramCounter(xxx)		0
#	define	SimGetFloatingPointRegisterWord(xxx)\
			this->FloatingPointRegisters[xxx]
#	define	SimSetFloatingPointRegisterWord(xxx, expr)\
				(this->FloatingPointRegisters[xxx] = (SimRegister)(expr))
#	define	SimGetFloatingPointRegisterSingle(xxx)\
				this->FloatingPointRegistersSingleAccess[xxx]
#	define	SimSetFloatingPointRegisterSingle(xxx, expr)\
				(this->FloatingPointRegistersSingleAccess[xxx]=\
					(SimSingle)(expr))
#	define	SimGetFloatingPointRegisterDouble(xxx)\
				(this->FloatingPointRegistersDoubleAccess[xxx>>1])
#	define	SimSetFloatingPointRegisterDouble(xxx, expr)\
				(this->FloatingPointRegistersDoubleAccess[xxx>>1]\
				= (SimDouble)(expr))

#	define	SimMemoryRead8(xxx)			ReadDataMemory8(xxx)
#	define	SimMemoryRead16(xxx)		ReadDataMemory16(xxx)
#	define	SimMemoryRead32(xxx)		ReadDataMemory32(xxx)
#	define	SimMemoryWrite8(xxx,ddd)	WriteDataMemory8(xxx, ddd)
#	define	SimMemoryWrite16(xxx,ddd)	WriteDataMemory16(xxx, ddd)
#	define	SimMemoryWrite32(xxx,ddd)	WriteDataMemory32(xxx, ddd)

#	define	ImplementingProcessorSupportFunctions
#	define	ProcessorClass	SingleIssueProcessor
#	include	"ss.def"
#	undef	ImplementingProcessorSupportFunctions

int
SingleIssueProcessor	::	SimulateOneClockCycle()
	{
	if(Halted)	return(-1);
	if( Stalled > 0)
		{
		--Stalled;
		return ( 1 );
		}

	if ( (ProgramCounter > 0x10000000)||(ProgramCounter < 0x00400000))
		{
		fprintf(stderr, "SEG-FAULT ON PROGRAM COUNTER: %x\n", ProgramCounter);
		exit(1);
		}
	int	Temp1, Temp2;

	++InstructionCount;
	SimInstruction	aCurrentInstruction;
	SimInstruction	*CurrentInstruction = &aCurrentInstruction;

	theInstructionMemorySystem->ScheduleOperation(false, ProgramCounter, 8,
		0, &Temp1, &Temp2);
	//printf("Temp2: %d\n", Temp2);
	Stalled += (Temp2-1);
	
	CurrentInstruction->ui[0] = theInstructionMemorySystem->ReadMemory32(
		ProgramCounter);
	CurrentInstruction->ui[1] = theInstructionMemorySystem->ReadMemory32(
		ProgramCounter+4);
/*
	printf("PC: %8.8x : ", ProgramCounter);
	printf("\t%8.8x|%8.8x: ",
		CurrentInstruction->ui[0],
		CurrentInstruction->ui[1]);
	DumpInstruction(CurrentInstruction);
	printf("\n");
	if((ProgramCounter>0x10000000)||(ProgramCounter<0x400000))
		{
		DumpState();
		exit(1);
		}
*/	
	GeneralPurposeRegisters[0] = 0;
	NextProgramCounter = ProgramCounter + 8;
	// Decode Instruction
	CurrentInstruction->ui[0] = (CurrentInstruction->ui[0] & ~0xff) |
		(uint) SimMaskToOpCode[SimInstructionOpCode(CurrentInstruction)];
	switch ( SimInstructionOpCode(CurrentInstruction) )
		{
#define	DNA	200
#define	DFCC	201
#define	DGPR(xxx)	(xxx)
#define	DCGPR(xxx)	(xxx)
#define	DGPR_D(xxx)	(xxx)
#define	DFPR(xxx)	((xxx)+32)
#define	DFPR_L(xxx)	((xxx)+32)
#define	DFPR_D(xxx)	((xxx)+32)
#define	DFPR_F(xxx)	((xxx)+32)
#define	DHI	202
#define	DLO	203

#define	DEFINST(TICKS,OP,MSK,NAME,OPFORM,RES,FLAGS,O1,O2,I1,I2,I3,EXPR) \
		case	OP:	\
			RegInstruction(ProgramCounter,OP, O1, O2, I1, I2, I3, FLAGS, InstructionCount);\
			EXPR;	\
			Stalled += (TICKS-1);\
			break;
#define	DEFLINK(OP,MSK,NAME,MASK,SHIFT)	\
		case	OP: \
			Simulator->PrintError\
				("Attempting to execute a linking opcode at %x\n",\
				ProgramCounter-8);\
			Stalled = 0;\
			break;
#define	CONNECT(OP)
#include	"ss.def"
#undef	DEFINST
#undef	DEFLINK
#undef	CONNECT
		}
	ProgramCounter = NextProgramCounter;
	return ( 1 );	// call back in 1 cycle
	}

uint8
SingleIssueProcessor	::	ReadDataMemory8(
	SimAddress	sa)
	{
	int	Temp1, Temp2;
	this->theDataMemorySystem->ScheduleOperation
		(false, sa&0x7fffffff, 1, 0, &Temp1, &Temp2);
	Stalled += Temp2;
	return(this->theDataMemorySystem->ReadMemory8(sa));
	}

uint16
SingleIssueProcessor	::	ReadDataMemory16(
	SimAddress	sa)
	{
	int	Temp1, Temp2;
	this->theDataMemorySystem->ScheduleOperation
		(false, sa&0x7fffffff, 2, 0, &Temp1, &Temp2);
	Stalled += Temp2;
	return(this->theDataMemorySystem->ReadMemory16(sa));
	}

uint32
SingleIssueProcessor	::	ReadDataMemory32(
	SimAddress	sa)
	{
	int	Temp1, Temp2;
	this->theDataMemorySystem->ScheduleOperation
		(false, sa&0x7fffffff, 4, 0, &Temp1, &Temp2);
	Stalled += Temp2;
	return(this->theDataMemorySystem->ReadMemory32(sa));
	}

bool
SingleIssueProcessor	::	WriteDataMemory8(
	SimAddress	sa,
	uint8		Data)
	{
	int	Temp1, Temp2;
	this->theDataMemorySystem->ScheduleOperation
		(true, sa&0x7fffffff, 1, 0, &Temp1, &Temp2);
	Stalled += Temp2;
	return(this->theDataMemorySystem->WriteMemory8(sa, Data));
	}

bool
SingleIssueProcessor	::	WriteDataMemory16(
	SimAddress	sa,
	uint16		Data)
	{
	int	Temp1, Temp2;
	this->theDataMemorySystem->ScheduleOperation
		(true, sa&0x7fffffff, 2, 0, &Temp1, &Temp2);
	Stalled += Temp2;
	return(this->theDataMemorySystem->WriteMemory16(sa, Data));
	}

bool
SingleIssueProcessor	::	WriteDataMemory32(
	SimAddress	sa,
	uint32		Data)
	{
	int	Temp1, Temp2;
	this->theDataMemorySystem->ScheduleOperation
		(true, sa&0x7fffffff, 4, 0, &Temp1, &Temp2);
	Stalled += Temp2;
	return(this->theDataMemorySystem->WriteMemory32(sa, Data));
	}

bool
SingleIssueProcessor	::	DumpState()
	{
	printf(" PC: %8.8x FCC: %8.8x  HI: %8.8x  LO: %8.8x\n",
		ProgramCounter, FloatingPointConditionalFlags, High, Low);

	int	Row, Column;
	Row = 0;
	while(Row < 8)
		{
		Column = 0;
		while(Column<4)
			{	
			printf("r%2.2d: %8.8x ", Row *4 + Column,
				GeneralPurposeRegisters[Row*4+Column]);
			++Column;
			}
		printf("\n");
		++Row;
		}
	
	int	Index = 0;
	SimRegister	R = GeneralPurposeRegisters[29];

	while(R < 0x7fff0000)
		{
		printf("Stack: %8.8x : %8.8x - %d\n",
			R, theDataMemorySystem->ReadMemory32(R),
			theDataMemorySystem->ReadMemory32(R));
		R += 4;
		++Index;
		if(Index>=32)
			{
			getchar();
			Index = 0;
			}
		}
	return(true);
	}


