/********
#	define	SimSetGeneralPurposeRegister(xxx,yyy)	\
		(this->GeneralPurposeRegisters[xxx]=yyy)
#	define	SimGetGeneralPurposeRegister(xxx)	\
		(this->GeneralPurposeRegisters[xxx])
#	define	SimSetHighRegister(xxx)	(this->High = xxx)
#	define	SimGetHighRegister		this->High
#	define	SimSetLowRegister(xxx)	(this->Low = xxx)
#	define	SimGetLowRegister		this->Low
#	define	SimSetFCCRegister(xxx)	(this->FloatingPointConditionalFlags = xxx)
#	define	SimGetFCCRegister		this->FloatingPointConditionalFlags
#	define	SimSetProgramCounter(xxx)	(this->NextProgramCounter = xxx)
#	define	SimGetProgramCounter	this->ProgramCounter
#	define	SimSetTargetProgramCounter(xxx)		0
#	define	SimGetFloatingPointRegisterWord(xxx)\
			this->FloatingPointRegisters[xxx]
#	define	SimSetFloatingPointRegisterWord(xxx, expr)\
				(this->FloatingPointRegisters[xxx] = (SimRegister)(expr))
#	define	SimGetFloatingPointRegisterSingle(xxx)\
				this->FloatingPointRegistersSingleAccess[xxx]
#	define	SimSetFloatingPointRegisterSingle(xxx, expr)\
				(this->FloatingPointRegistersSingleAccess[xxx]=\
					(SimSingle)(expr))
#	define	SimGetFloatingPointRegisterDouble(xxx)\
				(this->FloatingPointRegistersDoubleAccess[xxx>>1])
#	define	SimSetFloatingPointRegisterDouble(xxx, expr)\
				(this->FloatingPointRegistersDoubleAccess[xxx>>1]\
				= (SimDouble)(expr))

#	define	SimMemoryRead8(xxx)			ReadDataMemory8(xxx)
#	define	SimMemoryRead16(xxx)		ReadDataMemory16(xxx)
#	define	SimMemoryRead32(xxx)		ReadDataMemory32(xxx)
#	define	SimMemoryWrite8(xxx,ddd)	WriteDataMemory8(xxx, ddd)
#	define	SimMemoryWrite16(xxx,ddd)	WriteDataMemory16(xxx, ddd)
#	define	SimMemoryWrite32(xxx,ddd)	WriteDataMemory32(xxx, ddd)
********/

class	SingleIssueProcessor	:
	public	Processor
	{
	public:
		bool		Halted;
		Counter		InstructionCount;
	public:
		SimRegister	GeneralPurposeRegisters[32];
		SimRegister	High;
		SimRegister	Low;
		SimRegister	FloatingPointRegisters[32];
		SimRegister	FloatingPointConditionalFlags;
		SimRegister	ProgramCounter;
		SimRegister	NextProgramCounter;
		SimDouble	*FloatingPointRegistersDoubleAccess;
		SimSingle	*FloatingPointRegistersSingleAccess;
		MemorySystem		*theDataMemorySystem;
		MemorySystem		*theInstructionMemorySystem;
		SystemTrapHandler	*theSystemTrapHandler;
		int			Stalled;

					SingleIssueProcessor();
		int			SimulateOneClockCycle();
		bool		Halt();
		bool		NotifyAboutStall(Component	*From, int	Cycles);
		bool		ConnectDataMemory(MemorySystem *ms)
			{ theDataMemorySystem = ms;return ( true ); }
		bool		ConnectInstructionMemory(MemorySystem *ms)
			{ theInstructionMemorySystem = ms;return ( true ); }
		bool		ConnectSystemTrapHandler(SystemTrapHandler *sth)
			{ theSystemTrapHandler = sth;return ( true ); }
	private:
#	define	DefiningProcessorSupportFunctions
#	include	"ss.def"
#	undef	DefiningProcessorSupportFunctions

	void	PerformSystemTrapFunction(SimInstruction	*At)
				{ theSystemTrapHandler->HandleSystemTrap(this, At); }
	void	PerformSystemCallFunction(SimInstruction	*At)
				{ theSystemTrapHandler->HandleSystemTrap(this, At); }

		bool		DumpState();
	public:
		// Accessors
		SimRegister	*GetIntegerRegisterSet()
			{ return(GeneralPurposeRegisters); }
		SimRegister	*GetFloatingPointRegisterSet()
			{return(FloatingPointRegisters); }
		SimRegister	*GetHigh()
			{ return(&High); }
		SimRegister	*GetLow()
			{ return(&Low); }
		SimRegister	*GetProgramCounter()
			{ return(&ProgramCounter); }
		SimRegister	*GetFloatingPointConditionalFlags()
			{ return(&FloatingPointConditionalFlags); }
		SimSingle	*GetFloatingPointRegisterSetAsSingle()
			{ return(FloatingPointRegistersSingleAccess); }
		SimDouble	*GetFloatingPointRegisterSetAsDouble()
			{ return(FloatingPointRegistersDoubleAccess); }
		MemorySystem	*GetDataMemorySystem()
			{ return(theDataMemorySystem); }
		MemorySystem	*GetInstructionMemorySystem()
			{ return(theInstructionMemorySystem); }
	public:
		bool	PrintStatistics(int	Format=HumanFormat, FILE	*fp=stdout);

	public:
		uint8		ReadDataMemory8(SimAddress	s);
		uint16		ReadDataMemory16(SimAddress	s);
		uint32		ReadDataMemory32(SimAddress	s);
		bool		WriteDataMemory8(SimAddress	s,	uint8	Data);
		bool		WriteDataMemory16(SimAddress	s, uint16	Data);
		bool		WriteDataMemory32(SimAddress	s, uint32	Data);
	};
